//---------------------------------------------------------------------------


#pragma hdrstop

#include "TiePieDLLObj.h"

//---------------------------------------------------------------------------

#pragma package(smart_init)

__fastcall TTiePieInstrument::TTiePieInstrument( TComponent* AOwner ) : TComponent( AOwner ) {
}

__fastcall TTiePieInstrument::~TTiePieInstrument( void ) {
  FreeLibrary( FDLLHandle );
}

bool __fastcall TTiePieInstrument::OpenDLL( LPCTSTR sPath ) {
  FDLLHandle = LoadLibrary( sPath );
  if ( FDLLHandle ) {
    RetrieveAllProcAddresses();
    return 1;
  } else
    return 0;
}

void __fastcall TTiePieInstrument::RetrieveAllProcAddresses( void ) {
//  Open / Close the instrument:
  FInitInstrument = (LPFN_InitInstrument) GetProcAddress( FDLLHandle, "InitInstrument" );
  FExitInstrument = (LPFN_ExitInstrument) GetProcAddress( FDLLHandle, "ExitInstrument" );
 
//  Get information about the instrument:
  FGetCalibrationDate = (LPFN_GetCalibrationDate) GetProcAddress( FDLLHandle, "GetCalibrationDate" );
  FGetSerialNumber = (LPFN_GetSerialNumber) GetProcAddress( FDLLHandle, "GetSerialNumber" );
  FGetAvailableSensitivities = (LPFN_GetAvailableSensitivities) GetProcAddress( FDLLHandle, "GetAvailableSensitivities" );
  FGetAvailableResolutions = (LPFN_GetAvailableResolutions) GetProcAddress( FDLLHandle, "GetAvailableResolutions" );
  FGetNrChannels = (LPFN_GetNrChannels) GetProcAddress( FDLLHandle, "GetNrChannels" );
  FGetMaxSampleFrequencyF = (LPFN_GetMaxSampleFrequencyF) GetProcAddress( FDLLHandle, "GetMaxSampleFrequencyF" );
  FGetMaxRecordLength = (LPFN_GetMaxRecordLength) GetProcAddress( FDLLHandle, "GetMaxRecordLength" );
  FGetDCLevelStatus = (LPFN_GetDCLevelStatus) GetProcAddress( FDLLHandle, "GetDCLevelStatus" );
 
//  Measurement routines:
  FADC_Start = (LPFN_ADC_Start) GetProcAddress( FDLLHandle, "ADC_Start" );
  FADC_Running = (LPFN_ADC_Running) GetProcAddress( FDLLHandle, "ADC_Running" );
  FADC_Abort = (LPFN_ADC_Abort) GetProcAddress( FDLLHandle, "ADC_Abort" );
  FADC_ForceTrig = (LPFN_ADC_ForceTrig) GetProcAddress( FDLLHandle, "ADC_ForceTrig" );
  FADC_Triggered = (LPFN_ADC_Triggered) GetProcAddress( FDLLHandle, "ADC_Triggered" );
  FADC_Ready = (LPFN_ADC_Ready) GetProcAddress( FDLLHandle, "ADC_Ready" );
 
//  Retrieve the measured data:
  FADC_GetDataCh = (LPFN_ADC_GetDataCh) GetProcAddress( FDLLHandle, "ADC_GetDataCh" );
  FADC_GetDataVoltCh = (LPFN_ADC_GetDataVoltCh) GetProcAddress( FDLLHandle, "ADC_GetDataVoltCh" );
  FGetDigitalInputValues = (LPFN_GetDigitalInputValues) GetProcAddress( FDLLHandle, "GetDigitalInputValues" );
  FGetOneDigitalValue = (LPFN_GetOneDigitalValue) GetProcAddress( FDLLHandle, "GetOneDigitalValue" );
 
//  Control the input resolution in bits:
  FSetResolution = (LPFN_SetResolution) GetProcAddress( FDLLHandle, "SetResolution" );
  FGetResolution = (LPFN_GetResolution) GetProcAddress( FDLLHandle, "GetResolution" );
 
//  Control the instrument configuration:
  FSetInstrumentConfig = (LPFN_SetInstrumentConfig) GetProcAddress( FDLLHandle, "SetInstrumentConfig" );
 
//  Control which channels are measured:
  FGetMeasureMode = (LPFN_GetMeasureMode) GetProcAddress( FDLLHandle, "GetMeasureMode" );
  FSetMeasureMode = (LPFN_SetMeasureMode) GetProcAddress( FDLLHandle, "SetMeasureMode" );
  FGetChEnabled = (LPFN_GetChEnabled) GetProcAddress( FDLLHandle, "GetChEnabled" );
  FSetChEnabled = (LPFN_SetChEnabled) GetProcAddress( FDLLHandle, "SetChEnabled" );
 
//  Control the time base:
  FGetRecordLength = (LPFN_GetRecordLength) GetProcAddress( FDLLHandle, "GetRecordLength" );
  FSetRecordLength = (LPFN_SetRecordLength) GetProcAddress( FDLLHandle, "SetRecordLength" );
  FGetPostSamples = (LPFN_GetPostSamples) GetProcAddress( FDLLHandle, "GetPostSamples" );
  FSetPostSamples = (LPFN_SetPostSamples) GetProcAddress( FDLLHandle, "SetPostSamples" );
  FGetSampleFrequencyF = (LPFN_GetSampleFrequencyF) GetProcAddress( FDLLHandle, "GetSampleFrequencyF" );
  FSetSampleFrequencyF = (LPFN_SetSampleFrequencyF) GetProcAddress( FDLLHandle, "SetSampleFrequencyF" );
  FGetExternalClock = (LPFN_GetExternalClock) GetProcAddress( FDLLHandle, "GetExternalClock" );
  FSetExternalClock = (LPFN_SetExternalClock) GetProcAddress( FDLLHandle, "SetExternalClock" );
 
//  Control the analog input channels:
  FGetSensitivity = (LPFN_GetSensitivity) GetProcAddress( FDLLHandle, "GetSensitivity" );
  FSetSensitivity = (LPFN_SetSensitivity) GetProcAddress( FDLLHandle, "SetSensitivity" );
  FGetAutoRanging = (LPFN_GetAutoRanging) GetProcAddress( FDLLHandle, "GetAutoRanging" );
  FSetAutoRanging = (LPFN_SetAutoRanging) GetProcAddress( FDLLHandle, "SetAutoRanging" );
  FGetCoupling = (LPFN_GetCoupling) GetProcAddress( FDLLHandle, "GetCoupling" );
  FSetCoupling = (LPFN_SetCoupling) GetProcAddress( FDLLHandle, "SetCoupling" );
  FGetDcLevel = (LPFN_GetDcLevel) GetProcAddress( FDLLHandle, "GetDcLevel" );
  FSetDcLevel = (LPFN_SetDcLevel) GetProcAddress( FDLLHandle, "SetDcLevel" );
 
//  Control the trigger system:
  FGetTriggerTimeOut = (LPFN_GetTriggerTimeOut) GetProcAddress( FDLLHandle, "GetTriggerTimeOut" );
  FSetTriggerTimeOut = (LPFN_SetTriggerTimeOut) GetProcAddress( FDLLHandle, "SetTriggerTimeOut" );
  FGetTriggerSource = (LPFN_GetTriggerSource) GetProcAddress( FDLLHandle, "GetTriggerSource" );
  FSetTriggerSource = (LPFN_SetTriggerSource) GetProcAddress( FDLLHandle, "SetTriggerSource" );
//  For more control, use these routines for trigger source, instead of the ones above:
  FGetTriggerSources = (LPFN_GetTriggerSources) GetProcAddress( FDLLHandle, "GetTriggerSources" );
  FGetTriggerSourceOR = (LPFN_GetTriggerSourceOR) GetProcAddress( FDLLHandle, "GetTriggerSourceOR" );
  FSetTriggerSourceOR = (LPFN_SetTriggerSourceOR) GetProcAddress( FDLLHandle, "SetTriggerSourceOR" );
  FGetTriggerSourceAND = (LPFN_GetTriggerSourceAND) GetProcAddress( FDLLHandle, "GetTriggerSourceAND" );
  FSetTriggerSourceAND = (LPFN_SetTriggerSourceAND) GetProcAddress( FDLLHandle, "SetTriggerSourceAND" );
  FGetTriggerMode = (LPFN_GetTriggerMode) GetProcAddress( FDLLHandle, "GetTriggerMode" );
  FSetTriggerMode = (LPFN_SetTriggerMode) GetProcAddress( FDLLHandle, "SetTriggerMode" );
  FGetTriggerModeCh = (LPFN_GetTriggerModeCh) GetProcAddress( FDLLHandle, "GetTriggerModeCh" );
  FSetTriggerModeCh = (LPFN_SetTriggerModeCh) GetProcAddress( FDLLHandle, "SetTriggerModeCh" );
  FGetTriggerLevel = (LPFN_GetTriggerLevel) GetProcAddress( FDLLHandle, "GetTriggerLevel" );
  FSetTriggerLevel = (LPFN_SetTriggerLevel) GetProcAddress( FDLLHandle, "SetTriggerLevel" );
  FGetTriggerHys = (LPFN_GetTriggerHys) GetProcAddress( FDLLHandle, "GetTriggerHys" );
  FSetTriggerHys = (LPFN_SetTriggerHys) GetProcAddress( FDLLHandle, "SetTriggerHys" );
  FGetPXITriggerEnables = (LPFN_GetPXITriggerEnables) GetProcAddress( FDLLHandle, "GetPXITriggerEnables" );
  FSetPXITriggerEnables = (LPFN_SetPXITriggerEnables) GetProcAddress( FDLLHandle, "SetPXITriggerEnables" );
  FGetPXITriggerSlopes = (LPFN_GetPXITriggerSlopes) GetProcAddress( FDLLHandle, "GetPXITriggerSlopes" );
  FSetPXITriggerSlopes = (LPFN_SetPXITriggerSlopes) GetProcAddress( FDLLHandle, "SetPXITriggerSlopes" );
 
//  Control the digital outputs:
  FSetDigitalOutputs = (LPFN_SetDigitalOutputs) GetProcAddress( FDLLHandle, "SetDigitalOutputs" );
  FGetDigitalOutputs = (LPFN_GetDigitalOutputs) GetProcAddress( FDLLHandle, "GetDigitalOutputs" );
 
//  Square Wave Generator:
  FGetSquareWaveGenStatus = (LPFN_GetSquareWaveGenStatus) GetProcAddress( FDLLHandle, "GetSquareWaveGenStatus" );
  FGetSquareWaveGenFrequency = (LPFN_GetSquareWaveGenFrequency) GetProcAddress( FDLLHandle, "GetSquareWaveGenFrequency" );
  FSetSquareWaveGenFrequency = (LPFN_SetSquareWaveGenFrequency) GetProcAddress( FDLLHandle, "SetSquareWaveGenFrequency" );
 
//  Get information about the function generator:
  FGetFunctionGenStatus = (LPFN_GetFunctionGenStatus) GetProcAddress( FDLLHandle, "GetFunctionGenStatus" );
  FGetFuncGenMaxAmplitude = (LPFN_GetFuncGenMaxAmplitude) GetProcAddress( FDLLHandle, "GetFuncGenMaxAmplitude" );
 
//  Control the Arbitrary Waveform Generator:
  FGetFuncGenOutputOn = (LPFN_GetFuncGenOutputOn) GetProcAddress( FDLLHandle, "GetFuncGenOutputOn" );
  FSetFuncGenOutputOn = (LPFN_SetFuncGenOutputOn) GetProcAddress( FDLLHandle, "SetFuncGenOutputOn" );
  FGetFuncGenEnable = (LPFN_GetFuncGenEnable) GetProcAddress( FDLLHandle, "GetFuncGenEnable" );
  FSetFuncGenEnable = (LPFN_SetFuncGenEnable) GetProcAddress( FDLLHandle, "SetFuncGenEnable" );
  FGetFuncGenSignalType = (LPFN_GetFuncGenSignalType) GetProcAddress( FDLLHandle, "GetFuncGenSignalType" );
  FSetFuncGenSignalType = (LPFN_SetFuncGenSignalType) GetProcAddress( FDLLHandle, "SetFuncGenSignalType" );
  FGetFuncGenMode = (LPFN_GetFuncGenMode) GetProcAddress( FDLLHandle, "GetFuncGenMode" );
  FSetFuncGenMode = (LPFN_SetFuncGenMode) GetProcAddress( FDLLHandle, "SetFuncGenMode" );
  FGetFuncGenAmplitude = (LPFN_GetFuncGenAmplitude) GetProcAddress( FDLLHandle, "GetFuncGenAmplitude" );
  FSetFuncGenAmplitude = (LPFN_SetFuncGenAmplitude) GetProcAddress( FDLLHandle, "SetFuncGenAmplitude" );
  FGetFuncGenDCOffset = (LPFN_GetFuncGenDCOffset) GetProcAddress( FDLLHandle, "GetFuncGenDCOffset" );
  FSetFuncGenDCOffset = (LPFN_SetFuncGenDCOffset) GetProcAddress( FDLLHandle, "SetFuncGenDCOffset" );
  FGetFuncGenSymmetry = (LPFN_GetFuncGenSymmetry) GetProcAddress( FDLLHandle, "GetFuncGenSymmetry" );
  FSetFuncGenSymmetry = (LPFN_SetFuncGenSymmetry) GetProcAddress( FDLLHandle, "SetFuncGenSymmetry" );
  FGetFuncGenFrequency = (LPFN_GetFuncGenFrequency) GetProcAddress( FDLLHandle, "GetFuncGenFrequency" );
  FSetFuncGenFrequency = (LPFN_SetFuncGenFrequency) GetProcAddress( FDLLHandle, "SetFuncGenFrequency" );
  FSetFuncGenTrigSource = (LPFN_SetFuncGenTrigSource) GetProcAddress( FDLLHandle, "SetFuncGenTrigSource" );
  FGetFuncGenTrigSource = (LPFN_GetFuncGenTrigSource) GetProcAddress( FDLLHandle, "GetFuncGenTrigSource" );
  FFillFuncGenMemory = (LPFN_FillFuncGenMemory) GetProcAddress( FDLLHandle, "FillFuncGenMemory" );
  FFuncGenBurst = (LPFN_FuncGenBurst) GetProcAddress( FDLLHandle, "FuncGenBurst" );
 
//  Control multiple Arbitrary Waveform Generators:
  FGetFunctionGeneratorCount = (LPFN_GetFunctionGeneratorCount) GetProcAddress( FDLLHandle, "GetFunctionGeneratorCount" );
 
  FGetFuncGenOutputOnCh = (LPFN_GetFuncGenOutputOnCh) GetProcAddress( FDLLHandle, "GetFuncGenOutputOnCh" );
  FSetFuncGenOutputOnCh = (LPFN_SetFuncGenOutputOnCh) GetProcAddress( FDLLHandle, "SetFuncGenOutputOnCh" );
  FGetFuncGenEnableCh = (LPFN_GetFuncGenEnableCh) GetProcAddress( FDLLHandle, "GetFuncGenEnableCh" );
  FSetFuncGenEnableCh = (LPFN_SetFuncGenEnableCh) GetProcAddress( FDLLHandle, "SetFuncGenEnableCh" );
  FGetFuncGenSignalTypeCh = (LPFN_GetFuncGenSignalTypeCh) GetProcAddress( FDLLHandle, "GetFuncGenSignalTypeCh" );
  FSetFuncGenSignalTypeCh = (LPFN_SetFuncGenSignalTypeCh) GetProcAddress( FDLLHandle, "SetFuncGenSignalTypeCh" );
  FGetFuncGenModeCh = (LPFN_GetFuncGenModeCh) GetProcAddress( FDLLHandle, "GetFuncGenModeCh" );
  FSetFuncGenModeCh = (LPFN_SetFuncGenModeCh) GetProcAddress( FDLLHandle, "SetFuncGenModeCh" );
  FGetFuncGenMaxAmplitudeCh = (LPFN_GetFuncGenMaxAmplitudeCh) GetProcAddress( FDLLHandle, "GetFuncGenMaxAmplitudeCh" );
  FGetFuncGenAmplitudeCh = (LPFN_GetFuncGenAmplitudeCh) GetProcAddress( FDLLHandle, "GetFuncGenAmplitudeCh" );
  FSetFuncGenAmplitudeCh = (LPFN_SetFuncGenAmplitudeCh) GetProcAddress( FDLLHandle, "SetFuncGenAmplitudeCh" );
  FGetFuncGenDCOffsetCh = (LPFN_GetFuncGenDCOffsetCh) GetProcAddress( FDLLHandle, "GetFuncGenDCOffsetCh" );
  FSetFuncGenDCOffsetCh = (LPFN_SetFuncGenDCOffsetCh) GetProcAddress( FDLLHandle, "SetFuncGenDCOffsetCh" );
  FGetFuncGenSymmetryCh = (LPFN_GetFuncGenSymmetryCh) GetProcAddress( FDLLHandle, "GetFuncGenSymmetryCh" );
  FSetFuncGenSymmetryCh = (LPFN_SetFuncGenSymmetryCh) GetProcAddress( FDLLHandle, "SetFuncGenSymmetryCh" );
  FGetFuncGenFrequencyCh = (LPFN_GetFuncGenFrequencyCh) GetProcAddress( FDLLHandle, "GetFuncGenFrequencyCh" );
  FSetFuncGenFrequencyCh = (LPFN_SetFuncGenFrequencyCh) GetProcAddress( FDLLHandle, "SetFuncGenFrequencyCh" );
  FGetFuncGenTrigSourceCh = (LPFN_GetFuncGenTrigSourceCh) GetProcAddress( FDLLHandle, "GetFuncGenTrigSourceCh" );
  FSetFuncGenTrigSourceCh = (LPFN_SetFuncGenTrigSourceCh) GetProcAddress( FDLLHandle, "SetFuncGenTrigSourceCh" );
  FFillFuncGenMemoryCh = (LPFN_FillFuncGenMemoryCh) GetProcAddress( FDLLHandle, "FillFuncGenMemoryCh" );
  FFuncGenBurstCh = (LPFN_FuncGenBurstCh) GetProcAddress( FDLLHandle, "FuncGenBurstCh" );
 
//  Ohm measurements ( not available by default ):
  FSetupOhmMeasurements = (LPFN_SetupOhmMeasurements) GetProcAddress( FDLLHandle, "SetupOhmMeasurements" );
  FGetOhmValues = (LPFN_GetOhmValues) GetProcAddress( FDLLHandle, "GetOhmValues" );
 
//  I2C routines:
  FI2CWrite = (LPFN_I2CWrite) GetProcAddress( FDLLHandle, "I2CWrite" );
  FI2CWriteNoStop = (LPFN_I2CWriteNoStop) GetProcAddress( FDLLHandle, "I2CWriteNoStop" );
  FI2CRead = (LPFN_I2CRead) GetProcAddress( FDLLHandle, "I2CRead" );
  FI2CReadNoStop = (LPFN_I2CReadNoStop) GetProcAddress( FDLLHandle, "I2CReadNoStop" );
  FI2CGetSpeed = (LPFN_I2CGetSpeed) GetProcAddress( FDLLHandle, "I2CGetSpeed" );
  FI2CSetSpeed = (LPFN_I2CSetSpeed) GetProcAddress( FDLLHandle, "I2CSetSpeed" );
 
//  I2C routines for acces to I2C-buses other than that of the first instrument:
  FI2CWriteCh = (LPFN_I2CWriteCh) GetProcAddress( FDLLHandle, "I2CWriteCh" );
  FI2CWriteNoStopCh = (LPFN_I2CWriteNoStopCh) GetProcAddress( FDLLHandle, "I2CWriteNoStopCh" );
  FI2CReadCh = (LPFN_I2CReadCh) GetProcAddress( FDLLHandle, "I2CReadCh" );
  FI2CReadNoStopCh = (LPFN_I2CReadNoStopCh) GetProcAddress( FDLLHandle, "I2CReadNoStopCh" );
  FI2CGetSpeedCh = (LPFN_I2CGetSpeedCh) GetProcAddress( FDLLHandle, "I2CGetSpeedCh" );
  FI2CSetSpeedCh = (LPFN_I2CSetSpeedCh) GetProcAddress( FDLLHandle, "I2CSetSpeedCh" );
 
//  Obsolete routines, use is deprecated:
  FStartMeasurement = (LPFN_StartMeasurement) GetProcAddress( FDLLHandle, "StartMeasurement" );
 
  FGetMeasurement = (LPFN_GetMeasurement) GetProcAddress( FDLLHandle, "GetMeasurement" );
  FGetMeasurementCh = (LPFN_GetMeasurementCh) GetProcAddress( FDLLHandle, "GetMeasurementCh" );
  FGetMeasurementRaw = (LPFN_GetMeasurementRaw) GetProcAddress( FDLLHandle, "GetMeasurementRaw" );
  FGetMeasurementRawCh = (LPFN_GetMeasurementRawCh) GetProcAddress( FDLLHandle, "GetMeasurementRawCh" );
  FGetOneMeasurement = (LPFN_GetOneMeasurement) GetProcAddress( FDLLHandle, "GetOneMeasurement" );
  FGetOneMeasurementCh = (LPFN_GetOneMeasurementCh) GetProcAddress( FDLLHandle, "GetOneMeasurementCh" );
  FGetOneMeasurementRaw = (LPFN_GetOneMeasurementRaw) GetProcAddress( FDLLHandle, "GetOneMeasurementRaw" );
  FGetOneMeasurementRawCh = (LPFN_GetOneMeasurementRawCh) GetProcAddress( FDLLHandle, "GetOneMeasurementRawCh" );
  FADC_GetData = (LPFN_ADC_GetData) GetProcAddress( FDLLHandle, "ADC_GetData" );
  FADC_GetDataVolt = (LPFN_ADC_GetDataVolt) GetProcAddress( FDLLHandle, "ADC_GetDataVolt" );
 
  FGetMaxSampleFrequency = (LPFN_GetMaxSampleFrequency) GetProcAddress( FDLLHandle, "GetMaxSampleFrequency" );
  FGetSampleFrequency = (LPFN_GetSampleFrequency) GetProcAddress( FDLLHandle, "GetSampleFrequency" );
  FSetSampleFrequency = (LPFN_SetSampleFrequency) GetProcAddress( FDLLHandle, "SetSampleFrequency" );
 
//  Streaming measurements:
  FSetDataReadyCallback = (LPFN_SetDataReadyCallback) GetProcAddress( FDLLHandle, "SetDataReadyCallback" );
  FSetDataReadyEvent = (LPFN_SetDataReadyEvent) GetProcAddress( FDLLHandle, "SetDataReadyEvent" );
  FSetTransferMode = (LPFN_SetTransferMode) GetProcAddress( FDLLHandle, "SetTransferMode" );
  FGetTransferMode = (LPFN_GetTransferMode) GetProcAddress( FDLLHandle, "GetTransferMode" );

}

//  Open / Close the instrument:
word __fastcall TTiePieInstrument::InitInstrument( word wInstrumentCount ) {
  return FInitInstrument( wInstrumentCount );
}

word __fastcall TTiePieInstrument::ExitInstrument() {
  return FExitInstrument();
}

 
//  Get information about the instrument:
word __fastcall TTiePieInstrument::GetCalibrationDate( dword* dwDate ) {
  return FGetCalibrationDate( dwDate );
}

word __fastcall TTiePieInstrument::GetSerialNumber( dword* dwSerialNumber ) {
  return FGetSerialNumber( dwSerialNumber );
}

word __fastcall TTiePieInstrument::GetAvailableSensitivities( double* dSensitivities ) {
  return FGetAvailableSensitivities( dSensitivities );
}

word __fastcall TTiePieInstrument::GetAvailableResolutions( double* dResolutions ) {
  return FGetAvailableResolutions( dResolutions );
}

word __fastcall TTiePieInstrument::GetNrChannels( word* wValue ) {
  return FGetNrChannels( wValue );
}

double __fastcall TTiePieInstrument::GetMaxSampleFrequencyF() {
  return FGetMaxSampleFrequencyF();
}

dword __fastcall TTiePieInstrument::GetMaxRecordLength() {
  return FGetMaxRecordLength();
}

dword __fastcall TTiePieInstrument::GetDCLevelStatus() {
  return FGetDCLevelStatus();
}

 
//  Measurement routines:
word __fastcall TTiePieInstrument::ADC_Start() {
  return FADC_Start();
}

word __fastcall TTiePieInstrument::ADC_Running() {
  return FADC_Running();
}

word __fastcall TTiePieInstrument::ADC_Abort() {
  return FADC_Abort();
}

word __fastcall TTiePieInstrument::ADC_ForceTrig() {
  return FADC_ForceTrig();
}

word __fastcall TTiePieInstrument::ADC_Triggered() {
  return FADC_Triggered();
}

word __fastcall TTiePieInstrument::ADC_Ready() {
  return FADC_Ready();
}

 
//  Retrieve the measured data:
word __fastcall TTiePieInstrument::ADC_GetDataCh( word wCh , word* wChData ) {
  return FADC_GetDataCh( wCh , wChData );
}

word __fastcall TTiePieInstrument::ADC_GetDataVoltCh( word wCh , double* dChData ) {
  return FADC_GetDataVoltCh( wCh , dChData );
}

word __fastcall TTiePieInstrument::GetDigitalInputValues( word* wValues ) {
  return FGetDigitalInputValues( wValues );
}

word __fastcall TTiePieInstrument::GetOneDigitalValue( dword dwIndex , word* wValue ) {
  return FGetOneDigitalValue( dwIndex , wValue );
}

 
//  Control the input resolution in bits:
word __fastcall TTiePieInstrument::SetResolution( byte byValue ) {
  return FSetResolution( byValue );
}

word __fastcall TTiePieInstrument::GetResolution( byte* byValue ) {
  return FGetResolution( byValue );
}

 
//  Control the instrument configuration:
word __fastcall TTiePieInstrument::SetInstrumentConfig( word wMode ) {
  return FSetInstrumentConfig( wMode );
}

 
//  Control which channels are measured:
word __fastcall TTiePieInstrument::GetMeasureMode( byte* byMode ) {
  return FGetMeasureMode( byMode );
}

word __fastcall TTiePieInstrument::SetMeasureMode( byte byMode ) {
  return FSetMeasureMode( byMode );
}

word __fastcall TTiePieInstrument::GetChEnabled( word wCh , byte* byEnabled ) {
  return FGetChEnabled( wCh , byEnabled );
}

word __fastcall TTiePieInstrument::SetChEnabled( word wCh , byte byEnabled ) {
  return FSetChEnabled( wCh , byEnabled );
}

 
//  Control the time base:
dword __fastcall TTiePieInstrument::GetRecordLength() {
  return FGetRecordLength();
}

word __fastcall TTiePieInstrument::SetRecordLength( dword dwRecordLength ) {
  return FSetRecordLength( dwRecordLength );
}

dword __fastcall TTiePieInstrument::GetPostSamples() {
  return FGetPostSamples();
}

word __fastcall TTiePieInstrument::SetPostSamples( dword dwPostSampleCount ) {
  return FSetPostSamples( dwPostSampleCount );
}

double __fastcall TTiePieInstrument::GetSampleFrequencyF() {
  return FGetSampleFrequencyF();
}

word __fastcall TTiePieInstrument::SetSampleFrequencyF( double* dFreq ) {
  return FSetSampleFrequencyF( dFreq );
}

word __fastcall TTiePieInstrument::GetExternalClock( word* wMode ) {
  return FGetExternalClock( wMode );
}

word __fastcall TTiePieInstrument::SetExternalClock( word wMode ) {
  return FSetExternalClock( wMode );
}

 
//  Control the analog input channels:
word __fastcall TTiePieInstrument::GetSensitivity( byte byCh , double* dSensitivity ) {
  return FGetSensitivity( byCh , dSensitivity );
}

word __fastcall TTiePieInstrument::SetSensitivity( byte byCh , double* dSensitivity ) {
  return FSetSensitivity( byCh , dSensitivity );
}

word __fastcall TTiePieInstrument::GetAutoRanging( byte byCh , byte* byMode ) {
  return FGetAutoRanging( byCh , byMode );
}

word __fastcall TTiePieInstrument::SetAutoRanging( byte byCh , byte byMode ) {
  return FSetAutoRanging( byCh , byMode );
}

word __fastcall TTiePieInstrument::GetCoupling( byte byCh , byte* byMode ) {
  return FGetCoupling( byCh , byMode );
}

word __fastcall TTiePieInstrument::SetCoupling( byte byCh , byte byMode ) {
  return FSetCoupling( byCh , byMode );
}

word __fastcall TTiePieInstrument::GetDcLevel( byte byCh , double* dDcLevel ) {
  return FGetDcLevel( byCh , dDcLevel );
}

word __fastcall TTiePieInstrument::SetDcLevel( byte byCh , double dDcLevel ) {
  return FSetDcLevel( byCh , dDcLevel );
}

 
//  Control the trigger system:
dword __fastcall TTiePieInstrument::GetTriggerTimeOut() {
  return FGetTriggerTimeOut();
}

word __fastcall TTiePieInstrument::SetTriggerTimeOut( dword dwTimeout ) {
  return FSetTriggerTimeOut( dwTimeout );
}

word __fastcall TTiePieInstrument::GetTriggerSource( byte* byTrigSource ) {
  return FGetTriggerSource( byTrigSource );
}

word __fastcall TTiePieInstrument::SetTriggerSource( byte byTrigSource ) {
  return FSetTriggerSource( byTrigSource );
}

//  For more control, use these routines for trigger source, instead of the ones above:
word __fastcall TTiePieInstrument::GetTriggerSources( int64* nTrigMask ) {
  return FGetTriggerSources( nTrigMask );
}

word __fastcall TTiePieInstrument::GetTriggerSourceOR( int64* nTrigMask ) {
  return FGetTriggerSourceOR( nTrigMask );
}

word __fastcall TTiePieInstrument::SetTriggerSourceOR( int64 nTrigMask ) {
  return FSetTriggerSourceOR( nTrigMask );
}

word __fastcall TTiePieInstrument::GetTriggerSourceAND( int64* nTrigMask ) {
  return FGetTriggerSourceAND( nTrigMask );
}

word __fastcall TTiePieInstrument::SetTriggerSourceAND( int64 nTrigMask ) {
  return FSetTriggerSourceAND( nTrigMask );
}

word __fastcall TTiePieInstrument::GetTriggerMode( byte* byMode ) {
  return FGetTriggerMode( byMode );
}

word __fastcall TTiePieInstrument::SetTriggerMode( byte byMode ) {
  return FSetTriggerMode( byMode );
}

word __fastcall TTiePieInstrument::GetTriggerModeCh( byte byCh , byte* byMode ) {
  return FGetTriggerModeCh( byCh , byMode );
}

word __fastcall TTiePieInstrument::SetTriggerModeCh( byte byCh , byte byMode ) {
  return FSetTriggerModeCh( byCh , byMode );
}

word __fastcall TTiePieInstrument::GetTriggerLevel( byte byCh , double* dLevel ) {
  return FGetTriggerLevel( byCh , dLevel );
}

word __fastcall TTiePieInstrument::SetTriggerLevel( byte byCh , double dLevel ) {
  return FSetTriggerLevel( byCh , dLevel );
}

word __fastcall TTiePieInstrument::GetTriggerHys( byte byCh , double* dHysteresis ) {
  return FGetTriggerHys( byCh , dHysteresis );
}

word __fastcall TTiePieInstrument::SetTriggerHys( byte byCh , double dHysteresis ) {
  return FSetTriggerHys( byCh , dHysteresis );
}

word __fastcall TTiePieInstrument::GetPXITriggerEnables( byte* byEnables ) {
  return FGetPXITriggerEnables( byEnables );
}

word __fastcall TTiePieInstrument::SetPXITriggerEnables( byte byEnables ) {
  return FSetPXITriggerEnables( byEnables );
}

word __fastcall TTiePieInstrument::GetPXITriggerSlopes( byte* bySlopes ) {
  return FGetPXITriggerSlopes( bySlopes );
}

word __fastcall TTiePieInstrument::SetPXITriggerSlopes( byte bySlopes ) {
  return FSetPXITriggerSlopes( bySlopes );
}

 
//  Control the digital outputs:
word __fastcall TTiePieInstrument::SetDigitalOutputs( byte byValue ) {
  return FSetDigitalOutputs( byValue );
}

word __fastcall TTiePieInstrument::GetDigitalOutputs( byte* byValue ) {
  return FGetDigitalOutputs( byValue );
}

 
//  Square Wave Generator:
word __fastcall TTiePieInstrument::GetSquareWaveGenStatus() {
  return FGetSquareWaveGenStatus();
}

dword __fastcall TTiePieInstrument::GetSquareWaveGenFrequency() {
  return FGetSquareWaveGenFrequency();
}

word __fastcall TTiePieInstrument::SetSquareWaveGenFrequency( dword* dwFreq ) {
  return FSetSquareWaveGenFrequency( dwFreq );
}

 
//  Get information about the function generator:
word __fastcall TTiePieInstrument::GetFunctionGenStatus() {
  return FGetFunctionGenStatus();
}

word __fastcall TTiePieInstrument::GetFuncGenMaxAmplitude( double* dMaxAmplitude ) {
  return FGetFuncGenMaxAmplitude( dMaxAmplitude );
}

 
//  Control the Arbitrary Waveform Generator:
word __fastcall TTiePieInstrument::GetFuncGenOutputOn( word* wValue ) {
  return FGetFuncGenOutputOn( wValue );
}

word __fastcall TTiePieInstrument::SetFuncGenOutputOn( word wValue ) {
  return FSetFuncGenOutputOn( wValue );
}

word __fastcall TTiePieInstrument::GetFuncGenEnable( word* wValue ) {
  return FGetFuncGenEnable( wValue );
}

word __fastcall TTiePieInstrument::SetFuncGenEnable( word wValue ) {
  return FSetFuncGenEnable( wValue );
}

word __fastcall TTiePieInstrument::GetFuncGenSignalType( word* wValue ) {
  return FGetFuncGenSignalType( wValue );
}

word __fastcall TTiePieInstrument::SetFuncGenSignalType( word wValue ) {
  return FSetFuncGenSignalType( wValue );
}

word __fastcall TTiePieInstrument::GetFuncGenMode( dword* dwMode ) {
  return FGetFuncGenMode( dwMode );
}

word __fastcall TTiePieInstrument::SetFuncGenMode( dword dwMode ) {
  return FSetFuncGenMode( dwMode );
}

word __fastcall TTiePieInstrument::GetFuncGenAmplitude( double* dValue ) {
  return FGetFuncGenAmplitude( dValue );
}

word __fastcall TTiePieInstrument::SetFuncGenAmplitude( double dValue ) {
  return FSetFuncGenAmplitude( dValue );
}

word __fastcall TTiePieInstrument::GetFuncGenDCOffset( double* dValue ) {
  return FGetFuncGenDCOffset( dValue );
}

word __fastcall TTiePieInstrument::SetFuncGenDCOffset( double dValue ) {
  return FSetFuncGenDCOffset( dValue );
}

word __fastcall TTiePieInstrument::GetFuncGenSymmetry( double* dValue ) {
  return FGetFuncGenSymmetry( dValue );
}

word __fastcall TTiePieInstrument::SetFuncGenSymmetry( double dValue ) {
  return FSetFuncGenSymmetry( dValue );
}

word __fastcall TTiePieInstrument::GetFuncGenFrequency( double* dValue ) {
  return FGetFuncGenFrequency( dValue );
}

word __fastcall TTiePieInstrument::SetFuncGenFrequency( double* dValue ) {
  return FSetFuncGenFrequency( dValue );
}

word __fastcall TTiePieInstrument::SetFuncGenTrigSource( byte byTrigSource ) {
  return FSetFuncGenTrigSource( byTrigSource );
}

word __fastcall TTiePieInstrument::GetFuncGenTrigSource( byte* byTrigSource ) {
  return FGetFuncGenTrigSource( byTrigSource );
}

word __fastcall TTiePieInstrument::FillFuncGenMemory( dword dwSampleCount , word* FuncGenData ) {
  return FFillFuncGenMemory( dwSampleCount , FuncGenData );
}

word __fastcall TTiePieInstrument::FuncGenBurst( word wNrPeriods ) {
  return FFuncGenBurst( wNrPeriods );
}

 
//  Control multiple Arbitrary Waveform Generators:
word __fastcall TTiePieInstrument::GetFunctionGeneratorCount() {
  return FGetFunctionGeneratorCount();
}

 
word __fastcall TTiePieInstrument::GetFuncGenOutputOnCh( word wCh , word* wValue ) {
  return FGetFuncGenOutputOnCh( wCh , wValue );
}

word __fastcall TTiePieInstrument::SetFuncGenOutputOnCh( word wCh , word wValue ) {
  return FSetFuncGenOutputOnCh( wCh , wValue );
}

word __fastcall TTiePieInstrument::GetFuncGenEnableCh( word wCh , word* wValue ) {
  return FGetFuncGenEnableCh( wCh , wValue );
}

word __fastcall TTiePieInstrument::SetFuncGenEnableCh( word wCh , word wValue ) {
  return FSetFuncGenEnableCh( wCh , wValue );
}

word __fastcall TTiePieInstrument::GetFuncGenSignalTypeCh( word wCh , word* wValue ) {
  return FGetFuncGenSignalTypeCh( wCh , wValue );
}

word __fastcall TTiePieInstrument::SetFuncGenSignalTypeCh( word wCh , word wValue ) {
  return FSetFuncGenSignalTypeCh( wCh , wValue );
}

word __fastcall TTiePieInstrument::GetFuncGenModeCh( word wCh , dword* dwMode ) {
  return FGetFuncGenModeCh( wCh , dwMode );
}

word __fastcall TTiePieInstrument::SetFuncGenModeCh( word wCh , dword dwMode ) {
  return FSetFuncGenModeCh( wCh , dwMode );
}

word __fastcall TTiePieInstrument::GetFuncGenMaxAmplitudeCh( word wCh , double* dValue ) {
  return FGetFuncGenMaxAmplitudeCh( wCh , dValue );
}

word __fastcall TTiePieInstrument::GetFuncGenAmplitudeCh( word wCh , double* dValue ) {
  return FGetFuncGenAmplitudeCh( wCh , dValue );
}

word __fastcall TTiePieInstrument::SetFuncGenAmplitudeCh( word wCh , double dValue ) {
  return FSetFuncGenAmplitudeCh( wCh , dValue );
}

word __fastcall TTiePieInstrument::GetFuncGenDCOffsetCh( word wCh , double* dValue ) {
  return FGetFuncGenDCOffsetCh( wCh , dValue );
}

word __fastcall TTiePieInstrument::SetFuncGenDCOffsetCh( word wCh , double dValue ) {
  return FSetFuncGenDCOffsetCh( wCh , dValue );
}

word __fastcall TTiePieInstrument::GetFuncGenSymmetryCh( word wCh , double* dValue ) {
  return FGetFuncGenSymmetryCh( wCh , dValue );
}

word __fastcall TTiePieInstrument::SetFuncGenSymmetryCh( word wCh , double dValue ) {
  return FSetFuncGenSymmetryCh( wCh , dValue );
}

word __fastcall TTiePieInstrument::GetFuncGenFrequencyCh( word wCh , double* dValue ) {
  return FGetFuncGenFrequencyCh( wCh , dValue );
}

word __fastcall TTiePieInstrument::SetFuncGenFrequencyCh( word wCh , double* dValue ) {
  return FSetFuncGenFrequencyCh( wCh , dValue );
}

word __fastcall TTiePieInstrument::GetFuncGenTrigSourceCh( word wCh , byte* byTrigSource ) {
  return FGetFuncGenTrigSourceCh( wCh , byTrigSource );
}

word __fastcall TTiePieInstrument::SetFuncGenTrigSourceCh( word wCh , byte byTrigSource ) {
  return FSetFuncGenTrigSourceCh( wCh , byTrigSource );
}

word __fastcall TTiePieInstrument::FillFuncGenMemoryCh( word wCh , dword dwSampleCount , word* FuncGenData ) {
  return FFillFuncGenMemoryCh( wCh , dwSampleCount , FuncGenData );
}

word __fastcall TTiePieInstrument::FuncGenBurstCh( word wCh , word wNrPeriods ) {
  return FFuncGenBurstCh( wCh , wNrPeriods );
}

 
//  Ohm measurements ( not available by default ):
word __fastcall TTiePieInstrument::SetupOhmMeasurements( word wMode ) {
  return FSetupOhmMeasurements( wMode );
}

word __fastcall TTiePieInstrument::GetOhmValues( double* dValue1 , double* dValue2 ) {
  return FGetOhmValues( dValue1 , dValue2 );
}

 
//  I2C routines:
word __fastcall TTiePieInstrument::I2CWrite( dword dwAddress , pointer pBuf , dword dwSize ) {
  return FI2CWrite( dwAddress , pBuf , dwSize );
}

word __fastcall TTiePieInstrument::I2CWriteNoStop( dword dwAddress , pointer pBuf , dword dwSize ) {
  return FI2CWriteNoStop( dwAddress , pBuf , dwSize );
}

word __fastcall TTiePieInstrument::I2CRead( dword dwAddress , pointer pBuf , dword dwSize ) {
  return FI2CRead( dwAddress , pBuf , dwSize );
}

word __fastcall TTiePieInstrument::I2CReadNoStop( dword dwAddress , pointer pBuf , dword dwSize ) {
  return FI2CReadNoStop( dwAddress , pBuf , dwSize );
}

word __fastcall TTiePieInstrument::I2CGetSpeed( dword* dwSpeed ) {
  return FI2CGetSpeed( dwSpeed );
}

word __fastcall TTiePieInstrument::I2CSetSpeed( dword* dwSpeed ) {
  return FI2CSetSpeed( dwSpeed );
}

 
//  I2C routines for acces to I2C-buses other than that of the first instrument:
word __fastcall TTiePieInstrument::I2CWriteCh( word wCh , dword dwAddress , pointer pBuf , dword dwSize ) {
  return FI2CWriteCh( wCh , dwAddress , pBuf , dwSize );
}

word __fastcall TTiePieInstrument::I2CWriteNoStopCh( word wCh , dword dwAddress , pointer pBuf , dword dwSize ) {
  return FI2CWriteNoStopCh( wCh , dwAddress , pBuf , dwSize );
}

word __fastcall TTiePieInstrument::I2CReadCh( word wCh , dword dwAddress , pointer pBuf , dword dwSize ) {
  return FI2CReadCh( wCh , dwAddress , pBuf , dwSize );
}

word __fastcall TTiePieInstrument::I2CReadNoStopCh( word wCh , dword dwAddress , pointer pBuf , dword dwSize ) {
  return FI2CReadNoStopCh( wCh , dwAddress , pBuf , dwSize );
}

word __fastcall TTiePieInstrument::I2CGetSpeedCh( word wCh , dword* dwSpeed ) {
  return FI2CGetSpeedCh( wCh , dwSpeed );
}

word __fastcall TTiePieInstrument::I2CSetSpeedCh( word wCh , dword* dwSpeed ) {
  return FI2CSetSpeedCh( wCh , dwSpeed );
}

 
//  Obsolete routines, use is deprecated:
word __fastcall TTiePieInstrument::StartMeasurement() {
  return FStartMeasurement();
}

 
word __fastcall TTiePieInstrument::GetMeasurement( double* dCh1 , double* dCh2 ) {
  return FGetMeasurement( dCh1 , dCh2 );
}

word __fastcall TTiePieInstrument::GetMeasurementCh( word wCh , double* dChData ) {
  return FGetMeasurementCh( wCh , dChData );
}

word __fastcall TTiePieInstrument::GetMeasurementRaw( word* wCh1 , word* wCh2 ) {
  return FGetMeasurementRaw( wCh1 , wCh2 );
}

word __fastcall TTiePieInstrument::GetMeasurementRawCh( word wCh , word* wChData ) {
  return FGetMeasurementRawCh( wCh , wChData );
}

word __fastcall TTiePieInstrument::GetOneMeasurement( dword dwIndex , double* dCh1 , double* dCh2 ) {
  return FGetOneMeasurement( dwIndex , dCh1 , dCh2 );
}

word __fastcall TTiePieInstrument::GetOneMeasurementCh( word wCh , dword dwIndex , double* dChData ) {
  return FGetOneMeasurementCh( wCh , dwIndex , dChData );
}

word __fastcall TTiePieInstrument::GetOneMeasurementRaw( dword dwIndex , word* wCh1 , word* wCh2 ) {
  return FGetOneMeasurementRaw( dwIndex , wCh1 , wCh2 );
}

word __fastcall TTiePieInstrument::GetOneMeasurementRawCh( word wCh , dword dwIndex , word* wChData ) {
  return FGetOneMeasurementRawCh( wCh , dwIndex , wChData );
}

word __fastcall TTiePieInstrument::ADC_GetData( word* wCh1 , word* wCh2 ) {
  return FADC_GetData( wCh1 , wCh2 );
}

word __fastcall TTiePieInstrument::ADC_GetDataVolt( double* dCh1 , double* dCh2 ) {
  return FADC_GetDataVolt( dCh1 , dCh2 );
}

 
dword __fastcall TTiePieInstrument::GetMaxSampleFrequency() {
  return FGetMaxSampleFrequency();
}

dword __fastcall TTiePieInstrument::GetSampleFrequency() {
  return FGetSampleFrequency();
}

word __fastcall TTiePieInstrument::SetSampleFrequency( dword* dwFreq ) {
  return FSetSampleFrequency( dwFreq );
}

 
//  Streaming measurements:
word __fastcall TTiePieInstrument::SetDataReadyCallback( TDataReady pAddress ) {
  return FSetDataReadyCallback( pAddress );
}

word __fastcall TTiePieInstrument::SetDataReadyEvent( HANDLE hEvent ) {
  return FSetDataReadyEvent( hEvent );
}

word __fastcall TTiePieInstrument::SetTransferMode( dword dwMode ) {
  return FSetTransferMode( dwMode );
}

word __fastcall TTiePieInstrument::GetTransferMode( dword* dwMode ) {
  return FGetTransferMode( dwMode );
}


